--- /dev/null	Mon Jul  1 21:15:23 2013
+++ new/usr/src/lib/libfsd/common/libfsd.c	Mon Jul  1 21:15:23 2013
@@ -0,0 +1,50 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2013 Damian Bogel. All rights reserved.
+ */
+
+/*
+ * TODO:
+ * fsd_open: return opaque handle (INVALID_FSD_HANDLE)
+ */
+
+#include <fcntl.h>
+#include <string.h>
+#include <stropts.h>
+#include <sys/fsd.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <unistd.h>
+
+int
+fsd_open()
+{
+	return (open(FSD_DEVICE_PATH, O_RDWR));
+}
+
+void
+fsd_close(int fd)
+{
+	(void) close(fd);
+}
+
+/* TODO: what about strlcpy and const char vs int8_t? */
+void
+fsd_print_msg(const char *msg, int fd)
+{
+	struct fsd_msg m;
+	m.len = strlen(msg);
+	m.len = strlcpy(m.s, msg, FSD_MAX_MSG_LEN);
+	(void) ioctl(fd, FSD_PRINT_MSG, (intptr_t)&m);
+
+}
